{
open Common;;
open Parser;;
exception Eof;;
}

let delim = [' ' '\t']
let bl = delim+
let chiffre = ['0'-'9']
let lettre = ['A'-'Z' 'a'-'z']
let id = (lettre | '_') (lettre | chiffre | '_' | '\'')*
let num = chiffre+
let break = ['\n']

rule token = parse
   bl                      { token lexbuf }
 | break                   { BREAK }
 | ','                     { COMMA }
 | '('                     { LPAR }
 | ')'                     { RPAR }
 | '['                     { LBRACK }
 | ']'                     { RBRACK }
 | '\\'                    { BACK }
 | '@'                     { ID("@") }
 | id                      { ID(Lexing.lexeme lexbuf) }
 | num                     { NUM(int_of_string (Lexing.lexeme lexbuf)) }
 | eof                     { raise Eof }
 | _                       { runtime_msg "Lexical error" }
